
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <assert.h>
#include <sys/time.h>
#include <limits.h>
#include "network.h"
#include <omp.h>
#include <gsl/gsl_math.h>
#include <gsl/gsl_rng.h>
#include <float.h>

int main(int argc, char **argv){

    /*  Input arguments are:                     */
    /*  1. Name of the run (and thus filenames)  */
    /*  2. Value of slope (b) after threshold    */
    

/*     int size = 256; */
/*     double start = walltime(); */
/* #pragma omp parallel for num_threads(2) schedule(dynamic) */
/*     for(int run=0; run<11; run++){ */
/* 	struct System A; */
/* 	allocSys(&A, size); */
/* 	if(run < 10){ */
/* 	    printf("Run %d\n", run); */
/* 	    double t1 = walltime(); */
/* 	    initSys(&A, 0, size+run+81, -1, 1); */
/* 	    breakFuseFast(&A); */
/* 	    printf("Network broken in %.6f\n\n", walltime()-t1); */
/* 	    int **backbone = getBackbone(A.updated, size); */
/* 	    int **sc = getFracture(A.updated, size); */

/* 	    fwriteBackbone(size, run, -90, backbone, sc, NULL); */
/* 	    for(int i=0; i<size*size; i++){ */
/* 		free(backbone[i]); */
/* 		free(sc[i]); */
/* 	    } */
/* 	    free(backbone); */
/* 	    free(sc); */
/* 	} */
/* 	else{ */
/* 	    initSys(&A, 0, size+3+81, -1, 1); */
/* 	    double t1 = walltime(); */
/* 	    printf("Finding pathscape\n"); */
/* 	    optimalPathscape(&A); */
/* 	    printf("Finished pathscape in %.6f\n\n", walltime()-t1); */
/* 	    fwritePathscape(&A); */
/* 	} */
/* 	freeSys(&A); */
/*     } */
/*     printf("\nFinished all in %.6f\n\n", walltime()-start); */

    /* printf("Running checkPrint()\n"); */
    /* checkPrint();  */


    /***********************/
    /*  CHECKING FRACTURE  */
    /***********************/

/*     int size = 256; */
/*     double theta = -90; */

/*     double gstart, lstart, phistart; */
/*     double phi = 45; */

/*     printf("\nBreaking fuse networks for different values of phi...\n\n"); */
/*     gstart = walltime(); */
/*     //for(double phi=10; phi<90; phi+=10){ */
/*     printf("Starting phi = %5f\n", phi); */
/*     phistart = walltime(); */
/* #pragma omp parallel for num_threads(2) schedule(dynamic) private(lstart) */
/*     for(int i=16; i<25; i++){ */
/* 	struct System A; */
/* 	allocSys(&A, size); */

/* 	int *nodes, **sc, **backbone; */
/* 	nodes = calloc((size+1)*(size+1)+1, sizeof(nodes));  /\*  is initialized in HK  *\/ */

/* 	lstart = walltime(); */
/* 	initSys(&A, theta, size+i+81, -1, 1); */
/* 	A.max_voltage = 0.001; */
/* 	/\* for(int j=0; j<size*size; j++){ *\/ */
/* 	/\* 	A.conductance[j][0] = tan(phi*M_PI/180); *\/ */
/* 	/\* 	A.conductance[j][1] = tan(phi*M_PI/180); *\/ */
/* 	/\* } *\/ */
	    
/* 	breakFuseFast(&A); */
/* 	//breakFuseNetwork(&A, i, theta); */
/* 	//breakNetwork(&A, i); */
/* 	breakBonds(&A); */
	    
/* 	sc = getFracture(A.updated, size); */
/* 	backbone = getBackbone(A.updated, size); */
/* 	HK(A.updated, nodes, size); */
	
/* #pragma omp critical */
/* 	{ */
/* 	fwriteBackbone(size, i, theta, backbone, sc, NULL, phi); */
/* 	} */
/* 	for(int j=0; j<size*size; j++){ */
/* 	    free(sc[j]); */
/* 	    free(backbone[j]); */
/* 	} */
	    
/* 	free(sc); */
/* 	free(backbone); */
/* 	free(nodes); */
/* 	freeSys(&A); */

/* 	printf("\t Finished run %d in %.6fs\n", i, walltime()-lstart); */
/*     } */
/*     printf("Finished phi = %.5f in %.6fs\n\n", phi, walltime()-phistart); */
/*     //} */
/*     printf("Finished all in %.6fs\n\n", walltime()-gstart); */
    


    /**********************************************/
    /* CHECKING RATIO FOR POSITIVE THETA AND PHI  */
    /**********************************************/

/*     int size = 64; */
/*     double phi = 45.49571196; */
/*     double theta = phi-45; */
/*     double dV = 0.001; */
/*     int broken_network = 0; */
/*     int breaklimit = size*size*6; */
/*     int updated_count = 0; */


/*     /\* for(int sys=0; sys<9; sys++){ *\/ */
/*     /\* 	if(sys == 0){ *\/ */
/*     /\* 	    phi = 45.49571196; *\/ */
/*     /\* 	    theta = 1; *\/ */
/*     /\* 	} *\/ */
/*     /\* 	else{ *\/ */
/*     /\* 	    phi = sys*10; *\/ */
/*     /\* 	    theta = 0; *\/ */
/*     /\* 	} *\/ */
/*     for(theta = 20; theta <= 30; theta += 10){ */
/* 	//double phi_list[5] = {45, 70, 85, 89, 89.999}; */
/*     double phi_list[4] = {45, 70, 85, 89}; */
/*     for(int k=0; k<4; k++){ */
/* 	//phi = phi_list[k]; */
/* 	double ratio = tan(phi_list[k]*M_PI/180)/tan(10*M_PI/180); */
/* 	//theta = 10; */
/* 	phi = atan(tan(theta*M_PI/180)*ratio)*180/M_PI; */

/* #pragma omp parallel for num_threads(2) schedule(dynamic) private(broken_network, updated_count) */
/* 	for(int i=0; i<4; i++){ */

/* 	    int *nodes, **sc, **backbone; */
/* 	    struct System A; */
/* 	    allocSys(&A, size); */
/* 	    nodes = calloc((size+1)*(size+1)+1, sizeof(nodes));  /\*  is initialized in HK  *\/ */
/* 	    double start = walltime(); */

/* 	    initSys(&A, theta, size+i+81, -1, 1); */
/* 	    A.max_voltage = dV; */
/* 	    for(int j=0; j<size*size; j++){ */
/* 		A.conductance[j][0] = tan(phi*M_PI/180); */
/* 		A.conductance[j][1] = tan(phi*M_PI/180); */
/* 	    } */

/* 	    broken_network = 0; */
/* 	    while( !broken_network ){ */

/* 		CG(&A); */
/* 		updated_count = 0; */
	
/* 		if(!broken_network){ */
/* 		    while(!broken_network &&  updateConductanceSingleElasticPhi(&A, phi)){ */
/* 			CG(&A); */
/* 			updateDV(&A); */
/* 			broken_network = HKV(A.updated, A.L); */

/* 			updated_count++; */

/* 			if(updated_count > breaklimit){ */
/* 			    printf("Breaklimit! Max voltage = %.4f, updated bonds = %d\n", A.max_voltage, A.num_updated_bonds); */
/* 			    break; */
/* 			} */
/* 		    } */
/* 		} */

/* 		if(!broken_network) */
/* 		    A.max_voltage += dV; */
/* 	    } */
/* 	    breakBonds(&A); */
	
/* 	    sc = getFracture(A.updated, size); */
/* 	    backbone = getBackbone(A.updated, size); */
/* 	    HK(A.updated, nodes, size); */

/* 	    #pragma omp critical */
/* 	    { */
/* 	    fwriteBackbone(size, i, theta, backbone, sc, NULL, phi); */
/* 	    } */

/* 	    printf("Phi = %.3f, theta = %.3f, run %d. Time spent: %.4fs\n",  */
/* 		   phi, theta, i, walltime()-start); */

/* 	    for(int j=0; j<size*size; j++){ */
/* 		free(sc[j]); */
/* 		free(backbone[j]); */
/* 	    } */
	
/* 	    free(sc); */
/* 	    free(backbone); */
/* 	    free(nodes); */
/* 	    freeSys(&A); */

/* 	} */
/*     } */
/*     } */



    /* int size = 256; */
    /* struct System A; */
    /* allocSys(&A, size); */
    /* initSys(&A, 0, size+0+81, -1, 1); */

    /* optimalPathscapeNEWTHATDIDNTREALLYHELP(&A); */
    /* freeSys(&A); */



    /***********************************/
    /*  CHECKING DIFFERENT RATIOS OF   */
    /*  tan(phi)/tan(theta) AND v/t.   */
    /*  CURRENT AS OF 28.04.           */
    /***********************************/
    //CURRENT ON DESKTOP (27.05)
    int size = 64;
    double phi = 45.49571196;
    double theta = phi-45;
    double dV = 0.001;
    int broken_network = 0;
    int breaklimit = size*size*6;
    int updated_count = 0;
    double alpha, beta, r;    // alpha = slope before t, beta slope after, r = alpha/beta
    theta = 20;
    theta = atan(0.5)*180/M_PI;
    //theta = 0.00003;
    /* for(phi = 89.9952; phi <= 89.999; phi += 990.99){ */
    /* 	phi = atan(500)*180/M_PI; */

    beta = 0.1;
    beta = 0;
    //for(r = 15000; r <= 15000; r *= 10){
	//for(beta = 0.1; beta < 1; beta += 0.4){
    alpha = 1;//r*beta;
#pragma omp parallel for num_threads(2) schedule(dynamic) private(broken_network, updated_count)
	for(int i=0; i<40; i++){
	    int *nodes, **sc, **backbone;
	    struct System A;
	    allocSys(&A, size);
	    nodes = calloc((size+1)*(size+1)+1, sizeof(nodes));  /*  is initialized in HK  */
	    double start = walltime();

	    int seed = size+i+81;
	    initSys(&A, 0, seed, -1, 1);
	    A.max_voltage = dV;
	    A.a = alpha;
	    A.b = beta;
	    /* gsl_rng *r = gsl_rng_alloc(gsl_rng_mt19937); */
	    /* gsl_rng_set(r, size+i+81); */
	    /* double lol; */
	    for(int j=0; j<size*size; j++){
		/* lol = gsl_rng_uniform(r)*90; */
		/* A.conductance[j][0] = tan(lol*M_PI/180); */
		/* A.threshold[j][0] = tan(lol*M_PI/180); */
		/* lol = gsl_rng_uniform(r)*90; */
		/* A.conductance[j][1] = tan(lol*M_PI/180); */
		/* A.threshold[j][1] = tan(lol*M_PI/180); */
		/* A.conductance[j][0] = tan(phi*M_PI/180); */
		/* A.conductance[j][1] = tan(phi*M_PI/180); */
		A.conductance[j][0] = alpha;
		A.conductance[j][1] = alpha;
	    }
	    /* gsl_rng_free(r); */

	    broken_network = 0;
	    while( !broken_network ){

	    	CG(&A);
	    	updated_count = 0;
	
	    	if(!broken_network){
	    	    while(!broken_network &&  updateConductanceSingleElasticPhi(&A, phi)){
	    		CG(&A);
	    		updateDV(&A);
	    		broken_network = HKV(A.updated, A.L);

	    		updated_count++;

	    		if(updated_count > breaklimit){
	    		    printf("Breaklimit! Max voltage = %.4f, updated bonds = %d\n", A.max_voltage, A.num_updated_bonds);
	    		    break;
	    		}
	    	    }
	    	}

	    	if(!broken_network)
	    	    A.max_voltage += dV;
	    }
	    breakBonds(&A);
	
	    sc = getFracture(A.updated, size);
	    backbone = getBackbone(A.updated, size);
	    HK(A.updated, nodes, size);

#pragma omp critical
	    {
		//fwriteBackbone(size, i, theta, backbone, sc, NULL, phi);
		fwriteBackboneR(size, i, r, alpha, beta, backbone, sc, NULL);
		FILE *outfile;
		char *txtfile;
		txtfile = calloc(80, sizeof(txtfile));
		//sprintf(txtfile, "OutputPS/PhiL%d/volt_run%d_theta%.5f_phi%.5f.txt", size, i, theta, phi);
		sprintf(txtfile, "OutputPS/PhiL%d/volt_run%d_r%.3f_alpha%.3f_beta%.3f.txt", size, i, r, alpha, beta);
		outfile = fopen(txtfile, "w");
		fprintf(outfile, "#L \t #Max. voltage \t #Max. voltage/L \t "
			"#Largest v/t ratio \t #Avg v/t ratio \t #tan(phi)/tan(theta)\n");
		fprintf(outfile, "%d \t %.4f \t %.8f \t %.8f \t %.8f \t %.8f\n", size, A.max_voltage,
			A.max_voltage/size, vtRatio(&A), vtRatioAvg(&A), tan(phi*M_PI/180)/tan(theta*M_PI/180));
		fclose(outfile);
		free(txtfile);

	
		txtfile = calloc(80, sizeof(txtfile));
		//sprintf(txtfile, "OutputPS/PhiL%d/vt_ratio_run%d_theta%.5f_phi%.5f.txt", size, i, theta, phi);
		sprintf(txtfile, "OutputPS/PhiL%d/vt_ratio_run%d_r%.3f_alpha%.3f_beta%.3f.txt", size, i, r, alpha, beta);
		outfile = fopen(txtfile, "w");
		fprintf(outfile, "#Ratio v/t for all bonds\n");

		double **vt = calloc(size*size, sizeof(vt));
		for(int i=0; i<size*size; i++)
		    vt[i] = calloc(2, sizeof(vt[i]));
		getVTRatio(&A, vt);
		for(int i=size-1; i >= 0; i--){
		    for(int j=0; j < size; j++){
			fprintf(outfile, "(%.6f,%.6f) ", vt[i*size + j][0], vt[i*size + j][1]);
		    }
		    fprintf(outfile, "\n");
		}

	    	fclose(outfile);
		free(txtfile);
		for(int i=0; i<size*size; i++)
		    free(vt[i]);
		free(vt);

		/* txtfile = calloc(80, sizeof(txtfile)); */
		/* sprintf(txtfile, "OutputPS/PhiL%d/thresholds_run%d_theta%.5f_phi%.5f.txt", size, i, theta, phi); */
		/* outfile = fopen(txtfile, "w"); */
		/* fprintf(outfile, "#Thresholds for all bonds\n"); */

		/* for(int i=size-1; i >= 0; i--){ */
		/*     for(int j=0; j < size; j++){ */
		/* 	fprintf(outfile, "(%.8f,%.8f) ", A.threshold[i*size + j][0], A.threshold[i*size + j][1]); */
		/*     } */
		/*     fprintf(outfile, "\n"); */
		/* } */

	    	/* fclose(outfile); */
		/* free(txtfile); */

	    }

	    /* printf("  Phi = %.3f, theta = %.3f, run %d. Time spent: %.4fs\n", */
	    /* 	   phi, theta, i, walltime()-start); */
	    printf("  Alpha = %.3f, beta = %.3f, r = %.3f, run %d. Time spent: %.4fs\n",
		   alpha, beta, r, i, walltime()-start);
	    
	    printf("\t Max. voltage of system: %.4f, max. v/t ratio: %.4f\n",
		   A.max_voltage, vtRatio(&A));
	    
	    for(int j=0; j<size*size; j++){
	    	free(sc[j]);
	    	free(backbone[j]);
	    }
	
	    free(sc);
	    free(backbone);
	    free(nodes);
	    freeSys(&A);
	    
	}
	//}



    /***********************************/
    /*  CHECKING DIFFERENT RATIOS OF   */
    /*  tan(phi)/tan(theta) AND v/t.   */
    /////////////////////////////////////
    /*              END                */
    /***********************************/




    
    //double theta_list[9] = {89.99999, 89.99, 89, 85, 80, 75, 70, 65, 60};

/*     int size = 64; */
/*     double start = walltime(); */
    
/*     //for(int t=0; t<1; t++){ */
/* 	double theta = 90;//theta_list[t]; */
/* #pragma omp parallel for num_threads(2) schedule(dynamic) */
/* 	for(int i=4; i<50; i++){ */
/* 	    struct System A; */
/* 	    allocSys(&A, size); */
/* 	    initSys(&A, theta, size+i+81, -1, 1); */

/* /\* 	    printf("Finding pathscape\n"); *\/ */
/* /\* 	    optimalPathscapeFlow(&A); *\/ */

/* /\* #pragma omp critical *\/ */
/* /\* 	    { *\/ */
/* /\* 	    fwritePathscape(&A, i); *\/ */
/* /\* 	    } *\/ */

/* 	    A.max_voltage = 0.001; */
/* 	    while(HKV(A.updated, A.L) && A.max_voltage < size){ */
/* 	    	CG(&A); */
/* 	    	while(updateConductanceSuperconductingPure(&A) && HKV(A.updated, A.L)) */
/* 	    	    CG(&A); */
/* 	    	A.max_voltage += 0.001; */
/* 	    } */
/* 	    printf("Theta = %.5f, run %d:  %d  %.4f\n", */
/* 	    	   theta, i, A.num_updated_bonds, A.max_voltage); */
	    
/* #pragma omp critical */
/* 	    { */
/* 	    FILE *outfile; */
/* 	    char *txtfile; */
/* 	    txtfile = calloc(100, sizeof(char)); */
/* 	    sprintf(txtfile, "OutputPS/superconductingL%d/updated_bonds_run%d_theta_%.5f.txt",  */
/* 		    size, i, theta); */
/* 	    outfile = fopen(txtfile, "w"); */

/* 	    for(int j=0; j<size; j++) */
/* 	    	for(int k=0; k<size; k++){ */
/* 	    	    if(A.updated[j*size+k][0]) */
/* 	    		fprintf(outfile, "%d %d %d\n", j, k, 0); */
/* 	    	    if(A.updated[j*size+k][1]) */
/* 	    		fprintf(outfile, "%d %d %d\n", j, k, 1); */
/* 	    	} */

/* 	    fclose(outfile); */
/* 	    free(txtfile); */
/* 	    } */

/* 	    /\* printf("Finding pathscape\n"); *\/ */
/* 	    freeSys(&A); */
/* 	} */
/* 	//} */

/* 	//} */
/*     printf("Finished in %.6f\n\n", walltime()-start); */


/*     size = 128; */
/*     start = walltime(); */
    
/*     //for(int t=0; t<1; t++){ */
/*     theta = 90;//theta_list[t]; */
/* #pragma omp parallel for num_threads(2) schedule(dynamic) */
/* 	for(int i=1; i<30; i++){ */
/* 	    struct System A; */
/* 	    allocSys(&A, size); */
/* 	    initSys(&A, theta, size+i+81, -1, 1); */

/* 	    printf("Finding pathscape\n"); */
/* 	    optimalPathscapeFlow(&A); */

/* #pragma omp critical */
/* 	    { */
/* 	    fwritePathscape(&A, i); */
/* 	    } */

/* 	    A.max_voltage = 0.001; */
/* 	    while(HKV(A.updated, A.L) && A.max_voltage < size){ */
/* 	    	CG(&A); */
/* 	    	while(updateConductanceSuperconductingPure(&A) && HKV(A.updated, A.L)) */
/* 	    	    CG(&A); */
/* 	    	A.max_voltage += 0.001; */
/* 	    } */
/* 	    printf("Theta = %.5f, run %d:  %d  %.4f\n", */
/* 	    	   theta, i, A.num_updated_bonds, A.max_voltage); */
	    
/* #pragma omp critical */
/* 	    { */
/* 	    FILE *outfile; */
/* 	    char *txtfile; */
/* 	    txtfile = calloc(100, sizeof(char)); */
/* 	    sprintf(txtfile, "OutputPS/superconductingL%d/updated_bonds_run%d_theta_%.5f.txt", */
/* 	    	    size, i, theta); */
/* 	    outfile = fopen(txtfile, "w"); */

/* 	    for(int j=0; j<size; j++) */
/* 	    	for(int k=0; k<size; k++){ */
/* 	    	    if(A.updated[j*size+k][0]) */
/* 	    		fprintf(outfile, "%d %d %d\n", j, k, 0); */
/* 	    	    if(A.updated[j*size+k][1]) */
/* 	    		fprintf(outfile, "%d %d %d\n", j, k, 1); */
/* 	    	} */

/* 	    fclose(outfile); */
/* 	    free(txtfile); */
/* 	    } */

/* 	    /\* printf("Finding pathscape\n"); *\/ */
/* 	    freeSys(&A); */
/* 	} */
/* 	//} */

/* 	//} */
/*     printf("Finished in %.6f\n\n", walltime()-start); */
    
/*     int size = 64; */
/*     double global_start = walltime(); */
/* #pragma omp parallel for num_threads(2) schedule(dynamic) */
/*     for(int i=0; i<6; i++){ */
/*         struct System A; */
/*         allocSys(&A, size); */
/*         initSys(&A, 0, size+i+81, -1, 1); */
/*         double start = walltime(); */
/*         printf("Finding pathscape\n"); */
/*         optimalPathscapeNEWTHATDIDNTREALLYHELP(&A); // Actually, it did help... */
/*         printf("Finished pathscape %d in %.6f\n\n", i, walltime()-start); */
/*         /\* fwritePathscape(&A, i+2); *\/ */
/*         freeSys(&A); */
/*     } */
/*     printf("Finished all runs in %.4fs\n", walltime()-global_start); */
    
/*     start = walltime(); */
/*     printf("Running that checkprint stuff...\n\n"); */
/* #pragma omp parallel for num_threads(4) */
/*     for(int i=0; i<40; i++){ */
/* 	if(i < 20) */
/* 	    checkPrint(); */
/* 	else */
/* 	    checkPrintTrapping(); */
/*     } */
/*     printf("Finished checkprint in %.6f\n\n", walltime()-start); */

    /* benchmark(4); */

    return 0;
}
